#ifndef EFL_VPATH_MANAGER_EO_HH
#define EFL_VPATH_MANAGER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_vpath.eo.h"
#include "efl_vpath_file.eo.h"
#include "efl_vpath_manager.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_vpath.eo.hh"
#include "efl_vpath_file.eo.hh"
#include "eo_base.eo.hh"
namespace efl { namespace vpath { 
struct Manager;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::vpath::Manager> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace vpath { 
struct Manager {
    ::efl::vpath::File fetch( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   void cxx_register( ::efl::eolian::in_traits<int>::type priority,  ::efl::eolian::in_traits< ::efl::Vpath>::type vpath) const;
   void unregister( ::efl::eolian::in_traits< ::efl::Vpath>::type vpath) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_VPATH_MANAGER_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::vpath::Manager() const;
   operator ::efl::vpath::Manager&();
   operator ::efl::vpath::Manager const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Manager,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Manager const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace vpath { 
struct Manager : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Manager( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Manager(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Manager(Manager const& other) = default;
   Manager(Manager&& other) = default;
   Manager& operator=(Manager const& other) = default;
   Manager& operator=(Manager&& other) = default;
   Manager()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Manager( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Manager(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
    ::efl::vpath::File fetch( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   void cxx_register( ::efl::eolian::in_traits<int>::type priority,  ::efl::eolian::in_traits< ::efl::Vpath>::type vpath) const;
   void unregister( ::efl::eolian::in_traits< ::efl::Vpath>::type vpath) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_VPATH_MANAGER_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Manager,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Manager const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Manager) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Manager>::value, "");
} } 
#include "efl_vpath_manager.eo.impl.hh"
#endif
